#!/system/bin/sh
# Copyright (c) 2009-2010, Code Aurora Forum. All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Code Aurora nor
#       the names of its contributors may be used to endorse or promote
#       products derived from this software without specific prior written
#       permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

BLUETOOTH_SLEEP_PATH=/proc/bluetooth/sleep/proto
LOG_TAG="qcom-bluetooth"
LOG_NAME="${0}:"

hciattach_pid=""

loge ()
{
  /system/bin/log -t $LOG_TAG -p e "$LOG_NAME $@"
}

logi ()
{
  /system/bin/log -t $LOG_TAG -p i "$LOG_NAME $@"
}

failed ()
{
  loge "$1: exit code $2"
  exit $2
}

start_hciattach ()
{
  echo "echo start hciattach"
  logi "start hciattach"
#  echo 1 > $BLUETOOTH_SLEEP_PATH
#  /system/bin/hciattach -n $BTS_DEVICE $BTS_TYPE $BTS_BAUD &
#  /system/bin/hciattach -n -s 1500000 /dev/ttyHS0 bcm2035 &
/system/bin/brcm_patchram_plus   --enable_hci --patchram  /etc/firmware/BCM20710A1_001[1].002.014.0005.0007.hcd /dev/ttyMT1 --baudrate 1500000 --bd_addr 43:29:b1:55:00:01 --enable_lpm --config_pcm
  hciattach_pid=$!
  logi "start_hciattach: pid = $hciattach_pid"
}

kill_hciattach ()
{
  logi "kill_hciattach: pid = $hciattach_pid"
  ## careful not to kill zero or null!
#  kill -TERM $hciattach_pid
  kill -9 $hciattach_pid
#  echo 0 > $BLUETOOTH_SLEEP_PATH
   echo 0 > /sys/class/rfkill/rfkill0/state
   echo 0 > /proc/bluetooth/proto
  # this shell doesn't exit now -- wait returns for normal exit
}

# mimic hciattach options parsing -- maybe a waste of effort
#USAGE="hciattach [-n] [-p] [-b] [-t timeout] [-s initial_speed] <tty> <type | id> [speed] [flow|noflow] [bdaddr]"

#while getopts "blnpt:s:" f
#do
#  case $f in
#  b | l | n | p)  opt_flags="$opt_flags -$f" ;;
#  t)      timeout=$OPTARG;;
#  s)      initial_speed=$OPTARG;;
#  \?)     echo $USAGE; exit 1;;
#  esac
#done
#shift $(($OPTIND-1))

# Note that "hci_qcomm_init -e" prints expressions to set the shell variables
# BTS_DEVICE, BTS_TYPE, BTS_BAUD, and BTS_ADDRESS.

#eval $(/system/bin/hci_qcomm_init -e && echo "exit_code_hci_qcomm_init=0" || echo "exit_code_hci_qcomm_init=1")

#case $exit_code_hci_qcomm_init in
#  0) logi "Bluetooth QSoC firmware download succeeded, $BTS_DEVICE $BTS_TYPE $BTS_BAUD $BTS_ADDRESS";;
#  *) failed "Bluetooth QSoC firmware download failed" $exit_code_hci_qcomm_init;;
#esac

echo "start ***"
#echo 1 > /sys/class/rfkill/rfkill0/state
#sleep 1


# init does SIGTERM on ctl.stop for service
#trap "kill_hciattach" TERM INT
start_hciattach
#echo 1 > /proc/bluetooth/sleep/proto
wait $hciattach_pid

logi "Bluetooth stopped"

exit 0
